/** \file gdb-ese2.c
    
Un esempio di programma scorretto per l'allocazione e il 
riempimento della matrice bidimensionale in "percolation" 

*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int riempi(int **mat, int N, int val){	
	int i,j;
	for(i=0; i<N; i++){
		for(j=0; j<N; j++){
			mat[i][j]=1+rand()%(val+1);
			printf("%d",mat[i][j]);
		}
		printf("\n");
	}	
	return 0;
}

int alloca(int N){
	int **mat;
	int i = 0;
	mat=malloc(sizeof(int*)*N); //alloco per le righe
	for(i=0; i<N; i++){
		mat[i]=malloc(sizeof(int)*N); //alloco le colonne della matrice
	}	
	riempi(mat, N, 30); return 1;
}


int main(){
	(void)srand(time(NULL));
	if(alloca(5) == 0){ printf("ERRORE ALLOCAZIONE MEMORIA"); };
	return 1;
}
